from sys import argv
import struct

import DemofClient

class Dataf:
    def __init__(self, iv, sv):
        self.iv = iv
        self.sv = sv
    def __str__(self):
        return '{iv: %d, sv: %s}' % (self.iv, self.sv)
    def pack(self):
        return struct.pack('<l256s', self.iv, bytes(self.sv, 'iso-8859-1'))
    def unpack(self, blk):
        data = struct.unpack('<l256s', blk)
        self.iv = data[0]
        self.sv = str(data[1], 'iso-8859-1').rstrip(' \0')

cli = DemofClient.DemofClient(argv[1])
v1 = 123
v2 = 456
stat, v3 = cli.add(v1, v2)
print('stat = %d' % (stat))
print('%d + %d = %d' % (v1, v2, v3))
s1 = 'ABC'
s2 = 'DEF'
stat, s3 = cli.conc(s1, s2)        
print('stat = %d'% (stat))
print('|%s| + |%s| = |%s|' % (s1, s2, s3))
o = Dataf(123, 'ABC')
stat, o = cli.modify(o)
print('stat = %d'% (stat))
print('o = %s' % (o))
stat, idstr = cli.getid()
print('stat = %d' % (stat))
print('id = %s' % (idstr))
