#ifndef TIG_H
#define TIG_H

#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif
int16_t to_little_16(int16_t v);
int32_t to_little_32(int32_t v);
int64_t to_little_64(int64_t v);
int16_t from_little_16(int16_t v);
int32_t from_little_32(int32_t v);
int64_t from_little_64(int64_t v);

struct con_t
{
    int sd;
    char *buf;
    int32_t bufix;
    int32_t bufsiz;
};

struct con_t *con_init(const char *host, int port);
void con_prep(struct con_t *con);
void con_put_int8_t(struct con_t *con, int8_t v);
void con_put_int16_t(struct con_t *con, int16_t v);
void con_put_int32_t(struct con_t *con, int32_t v);
void con_put_int64_t(struct con_t *con, int64_t v);
void con_put_float(struct con_t *con, float v);
void con_put_double(struct con_t *con, double v);
void con_put_charptr(struct con_t *con, const char* v);
void con_put_block(struct con_t *con, void* v, int len);
void con_send(struct con_t *con);
void con_recv(struct con_t *con);
int8_t con_get_int8_t(struct con_t *con);
int16_t con_get_int16_t(struct con_t *con);
int32_t con_get_int32_t(struct con_t *con);
int64_t con_get_int64_t(struct con_t *con);
float con_get_float(struct con_t *con);
double con_get_double(struct con_t *con);
char* con_get_charptr(struct con_t *con);
void* con_get_block(struct con_t *con);
void con_close(struct con_t *con);
#ifdef __cplusplus
}
#endif

#endif
